Subject: [webfinger] Absolute URI vs URI

From: "Paul E. Jones" <[email-masked]>
Date: Mon, 22 Jul 2013 01:47:22 -0400

Folks,

One of the requirements in the JRD spec is that certain URIs (e.g., those
identifying link relation types and properties) be "absolute URIs".  This
term has been a point of confusion, since RFC 3986 uses the term to have a
concrete meaning, namely this:

     absolute-URI  = scheme ":" hier-part [ "?" query ]

And the term is used, because that's the term used in the OASIS XRD
specification.  However, it was not clear to me whether that referred to the
above (which I assumed) or referred to URIs that are not relative URIs
(i.e., those lacking a scheme specified).

I had an exchange with Eran Hammer and Mark Nottingham.  I believe the
intent of that language was not to require the above constrained syntax,
but to require the standard URI syntax:

     URI = scheme ":" hier-part [ "?" query ] [ "#" fragment ]

Given that understanding, I believe we should remove the word "absolute"
that appears in front of "URI" in the WebFinger spec.  Do others have an
opinion on this?

Paul

---

From: Tim Bray <[email-masked]>
Date: Sun, 21 Jul 2013 23:15:35 -0700

I just read your note 3 times, and I don’t get it.  3986 describes the
syntax of a “URI reference” to an absolute or relative URI.  A relative URI
reference can have an arbitrary number of leading parts missing, e.g.

//foo.bar/cat/dog?x=y
/cat/dog?x=y
./dog?x=y

When specs specify absolute URIs, they typically just mean you can’t omit
any leading parts, it has nothing to do with whether a #fragment is there
or not.  -T

On Sun, Jul 21, 2013 at 10:47 PM, Paul E. Jones <[email-masked]>wrote:

> _______________________________________________
> webfinger mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/webfinger
>

---

From: Melvin Carvalho <[email-masked]>
Date: Mon, 22 Jul 2013 08:46:25 +0200

>      URI = scheme ":" hier-part [ "?" query ] [ "#" fragment ]

There are many ways that people do this, see:

http://tantek.com/2011/238/b1/many-ways-slice-url-name-pieces

> that appears in front of "URI" in the WebFinger spec.  Do others have an

+1 on allowing relative URIs

---

From: "Paul E. Jones" <[email-masked]>
Date: Mon, 22 Jul 2013 03:03:16 -0400

There is a section in 3986 that defines "absolute-URI". The syntax doors not allow for a fragment.

I think the intent is to specify just "URI" and not absolute URI.

Paul

-------- Original Message --------
From: Tim Bray <[email-masked]>
Sent: Mon Jul 22 02:15:35 EDT 2013
To: "Paul E. Jones" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: Re: [webfinger] Absolute URI vs URI

//foo.bar/cat/dog?x=y
/cat/dog?x=y
./dog?x=y

---

From: "Paul E. Jones" <[email-masked]>
Date: Mon, 22 Jul 2013 03:06:57 -0400

In not suggesting we use or allow relative URIs. The immediate question would be "relative to what". I think the URIs should be absolute, but not following the syntax of "absolute-URI", but instead just following "URI".

Paul

---

From: Melvin Carvalho <[email-masked]>
Date: Mon, 22 Jul 2013 10:04:25 +0200

> I think the intent is to specify just "URI" and not absolute URI.
Ah right, yes.  Good catch.  Yes, I think the "Absolute" part there is
unnecessarily restrictive, and may limit interoperability.

> Paul
>
>
> ------------------------------
> *From:* Tim Bray <[email-masked]>
> *Sent:* Mon Jul 22 02:15:35 EDT 2013
> *To:* "Paul E. Jones" <[email-masked]>
> *Cc:* "[email-masked]" <[email-masked]>
> *Subject:* Re: [webfinger] Absolute URI vs URI
>

---

From: Melvin Carvalho <[email-masked]>
Date: Mon, 22 Jul 2013 10:08:49 +0200

On 22 July 2013 09:06, Paul E. Jones <[email-masked]> wrote:

> In not suggesting we use or allow relative URIs. The immediate question
> would be "relative to what". I think the URIs should be absolute, but not
> following the syntax of "absolute-URI", but instead just following "URI".
>
Yes, that's a good question.  Generally relative URIs are relative to the
document, but they need not be.  For example they could be relative by
default to the [supposed] webfinger registry.  In JSON LD they have a
@context variable which allows quite a bit of flexibility in this regard.
I'm unsure if relative URIs are considered a must in standards based
serialization (I suspect not) but they have the advantage of slightly
increased data portability.

> *From:* Melvin Carvalho <[email-masked]>
> *Sent:* Mon Jul 22 02:46:25 EDT 2013
>
> *Cc:* webfinger <[email-masked]>
>

---

From: "Paul E. Jones" <[email-masked]>
Date: Mon, 22 Jul 2013 10:10:00 -0400

Melvin,

It's easy enough to replace strings in URIs should data need to be ported.
I suggest we remove the word "absolute" where we currently have "absolute
URI" and then introduce a new paragraph in the terminology section as
follows:

The use of URIs throughout this document refers to URIs following the syntax
specified in Section 3 of RFC 3986.  Relative URIs, having syntax following
that of Section 4.2 or RFC 3986, are not used with WebFinger.

Is that clear?

Paul

From: Melvin Carvalho [mailto:[email-masked]] 
Sent: Monday, July 22, 2013 4:09 AM
To: Paul E. Jones
Cc: webfinger
Subject: Re: [webfinger] Absolute URI vs URI

Paul

  _____  

 

Folks,

Paul

---

From: John Bradley <[email-masked]>
Date: Mon, 22 Jul 2013 10:33:25 -0400

Yes +1.

On 2013-07-22, at 10:10 AM, "Paul E. Jones" <[email-masked]> wrote:

> Melvin,
>  
> It’s easy enough to replace strings in URIs should data need to be ported.  I suggest we remove the word “absolute” where we currently have “absolute URI” and then introduce a new paragraph in the terminology section as follows:
>  
> The use of URIs throughout this document refers to URIs following the syntax specified in Section 3 of RFC 3986.  Relative URIs, having syntax following that of Section 4.2 or RFC 3986, are not used with WebFinger.
>  
> Is that clear?
>  
> Paul
>  
> Yes, that's a good question.  Generally relative URIs are relative to the document, but they need not be.  For example they could be relative by default to the [supposed] webfinger registry.  In JSON LD they have a @context variable which allows quite a bit of flexibility in this regard.  I'm unsure if relative URIs are considered a must in standards based serialization (I suspect not) but they have the advantage of slightly increased data portability.
>  
> Paul
> 
>  
>

---

From: Nat Sakimura <[email-masked]>
Date: Tue, 23 Jul 2013 11:36:48 +0900

+1

2013/7/22 John Bradley <[email-masked]>

> Melvin,****
> It’s easy enough to replace strings in URIs should data need to be
> ported.  I suggest we remove the word “absolute” where we currently have
> “absolute URI” and then introduce a new paragraph in the terminology
> section as follows:****
>
> The use of URIs throughout this document refers to URIs following the
> syntax specified in Section 3 of RFC 3986.  Relative URIs, having syntax
> following that of Section 4.2 or RFC 3986, are not used with WebFinger.***
> *
>
> Is that clear?****
>
> Paul****
>
> *From:* Melvin Carvalho [mailto:[email-masked]]
> *Sent:* Monday, July 22, 2013 4:09 AM
> *To:* Paul E. Jones
> *Cc:* webfinger
> *Subject:* Re: [webfinger] Absolute URI vs URI****
> ** **
> ** **
>
> ** **
> On 22 July 2013 09:06, Paul E. Jones <[email-masked]> wrote:****
>
> following the syntax of "absolute-URI", but instead just following "URI".*
> ***
> increased data portability.****
>  ****
>
> Paul****
>
> ** **
> *Sent:* Mon Jul 22 02:46:25 EDT 2013****
>
> *To:* "Paul E. Jones" <[email-masked]>****
> *Cc:* webfinger <[email-masked]>****
>
> *Subject:* Re: [webfinger] Absolute URI vs URI****
> ** **
> ** **
> ** **
> ** **
> On 22 July 2013 07:47, Paul E. Jones <[email-masked]> wrote:****
> Folks,
>
>      URI = scheme ":" hier-part [ "?" query ] [ "#" fragment ]****
> ** **
> http://tantek.com/2011/238/b1/many-ways-slice-url-name-pieces****
>  ****
>
>
> opinion on this?****
> ** **
> +1 on allowing relative URIs****
>  ****
>
>
> Paul
>
>
> https://www.ietf.org/mailman/listinfo/webfinger****
>
> ** **
>
> ** **

-- 
Nat Sakimura (=nat)
Chairman, OpenID Foundation
http://nat.sakimura.org/
@_nat_en

---

From: Melvin Carvalho <[email-masked]>
Date: Wed, 24 Jul 2013 18:58:04 +0200

> following that of Section 4.2 or RFC 3986, are not used with WebFinger.***

Hi Paul, currently "Absolute URI" occurs only in section 4.4 (ie the
description of JRD).  Certainly I think the 'absolute' should be removed in
section 4.4.

The RFC in essence describes two things,

1. the webfinger protocol
2. the JRD definition

This restriction on relative URIs applies to (2), rather than, the whole
document, but as it happens that turns out to be the same thing

Side note: in other situations I like relative URIs because they can be
moved from one location to another in a non-breaking way.  Say I have
/about/ /photos/ /blog/ at one location, I can move them to another without
having to worry too much.  Therefore, if JRD was ever used in a context
outside of webfinger, that would be a slight advantage.

---

From: John Bradley <[email-masked]>
Date: Wed, 24 Jul 2013 13:19:00 -0400

Relative URI are not useful without a base to be relative to.  Unless we say how to determine the base of a relative URI they should not be allowed.

I an imagine several ways to determine a base but without specifying it applications will not behave consistently.   The JRD is not a HTML document.

John B.

On 2013-07-24, at 12:58 PM, Melvin Carvalho <[email-masked]> wrote:

> Hi Paul, currently "Absolute URI" occurs only in section 4.4 (ie the description of JRD).  Certainly I think the 'absolute' should be removed in section 4.4.  
> 
> This restriction on relative URIs applies to (2), rather than, the whole document, but as it happens that turns out to be the same thing
> 
> Side note: in other situations I like relative URIs because they can be moved from one location to another in a non-breaking way.  Say I have /about/ /photos/ /blog/ at one location, I can move them to another without having to worry too much.  Therefore, if JRD was ever used in a context outside of webfinger, that would be a slight advantage.
>  
> 
>  
> 
> Paul
> 
>  
>

---

From: Melvin Carvalho <[email-masked]>
Date: Wed, 24 Jul 2013 21:13:12 +0200

On 24 July 2013 19:19, John Bradley <[email-masked]> wrote:

> Relative URI are not useful without a base to be relative to.  Unless we
> say how to determine the base of a relative URI they should not be allowed.
>
> I an imagine several ways to determine a base but without specifying it
> applications will not behave consistently.   The JRD is not a HTML document.
>

Sure.  I wasnt trying to imply the JRD was the same as an HTML document.
Relative URIs, can be used in many contexts such as html/json/xml do indeed
require a base.  I think the following text from RFC 3986, "5.1.
Establishing a Base URI" would be relevant here, and it's referred to by
JSON LD too

http://tools.ietf.org/html/rfc3986#section-5.1

>> following that of Section 4.2 or RFC 3986, are not used with WebFinger.**
>> **
>>
>> ** **
>>
>> Is that clear?
>>
>

---

From: John Bradley <[email-masked]>
Date: Wed, 24 Jul 2013 15:22:55 -0400

I don't personally think the additional flexibility is worth the interop issues likely to be created by different parsers of the JRD attempting to interpret the base.

John B.

On 2013-07-24, at 3:13 PM, Melvin Carvalho <[email-masked]> wrote:

> Sure.  I wasnt trying to imply the JRD was the same as an HTML document.  Relative URIs, can be used in many contexts such as html/json/xml do indeed require a base.  I think the following text from RFC 3986, "5.1.  Establishing a Base URI" would be relevant here, and it's referred to by JSON LD too
>

---

From: Mike Jones <[email-masked]>
Date: Wed, 24 Jul 2013 19:42:19 +0000

Agreed.  We should continue to just specify the use of absolute URIs - for simplification and interop reasons.

                                                            -- Mike

From: [email-masked] [mailto:[email-masked]] On Behalf Of John Bradley
Sent: Wednesday, July 24, 2013 12:23 PM
To: Melvin Carvalho
Cc: Paul E. Jones; webfinger
Subject: Re: [webfinger] Absolute URI vs URI

John B.

On 2013-07-24, at 3:13 PM, Melvin Carvalho <[email-masked]<mailto:[email-masked]>> wrote:

On 24 July 2013 19:19, John Bradley <[email-masked]<mailto:[email-masked]>> wrote:
Relative URI are not useful without a base to be relative to.  Unless we say how to determine the base of a relative URI they should not be allowed.

John B.

On 2013-07-24, at 12:58 PM, Melvin Carvalho <[email-masked]<mailto:[email-masked]>> wrote:

On 22 July 2013 16:10, Paul E. Jones <[email-masked]<mailto:[email-masked]>> wrote:
Melvin,

It's easy enough to replace strings in URIs should data need to be ported.  I suggest we remove the word "absolute" where we currently have "absolute URI" and then introduce a new paragraph in the terminology section as follows:

Is that clear?

Paul

From: Melvin Carvalho [mailto:[email-masked]<mailto:[email-masked]>]
Sent: Monday, July 22, 2013 4:09 AM
To: Paul E. Jones
Cc: webfinger

On 22 July 2013 09:06, Paul E. Jones <[email-masked]<mailto:[email-masked]>> wrote:

Paul

________________________________
From: Melvin Carvalho <[email-masked]<mailto:[email-masked]>>
Sent: Mon Jul 22 02:46:25 EDT 2013

To: "Paul E. Jones" <[email-masked]<mailto:[email-masked]>>
Cc: webfinger <[email-masked]<mailto:[email-masked]>>

On 22 July 2013 07:47, Paul E. Jones <[email-masked]<mailto:[email-masked]>> wrote:
Folks,

Paul

_______________________________________________
webfinger mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/webfinger

_______________________________________________
webfinger mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/webfinger

---

From: "Paul E. Jones" <[email-masked]>
Date: Wed, 24 Jul 2013 18:01:39 -0400

Mike,

I took out the language 'absolute' since an absolute URI actually has a meaning other than what we are all calling absolute. What we want is "URI" per the RFC.

Paul

-------- Original Message --------
From: Mike Jones <[email-masked]>
Sent: Wed Jul 24 15:42:19 EDT 2013
To: John Bradley <[email-masked]>, Melvin Carvalho <[email-masked]>
Cc: "Paul E. Jones" <[email-masked]>, webfinger <[email-masked]>
Subject: RE: [webfinger] Absolute URI vs URI

                                                            -- Mike

John B.

John B.

Is that clear?

Paul

Paul

Paul

---

From: Mike Jones <[email-masked]>
Date: Wed, 24 Jul 2013 22:23:26 +0000

Fine with me

From: Paul E. Jones [mailto:[email-masked]]
Sent: Wednesday, July 24, 2013 3:02 PM
To: Mike Jones; John Bradley; Melvin Carvalho
Cc: webfinger
Subject: RE: [webfinger] Absolute URI vs URI

Mike,

Paul

________________________________
From: Mike Jones <[email-masked]<mailto:[email-masked]>>
Sent: Wed Jul 24 15:42:19 EDT 2013
To: John Bradley <[email-masked]<mailto:[email-masked]>>, Melvin Carvalho <[email-masked]<mailto:[email-masked]>>
Cc: "Paul E. Jones" <[email-masked]<mailto:[email-masked]>>, webfinger <[email-masked]<mailto:[email-masked]>>
Subject: RE: [webfinger] Absolute URI vs URI

Agreed.  We should continue to just specify the use of absolute URIs – for simplification and interop reasons.

                                                            -- Mike

From: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]] On Behalf Of John Bradley
Sent: Wednesday, July 24, 2013 12:23 PM
To: Melvin Carvalho
Cc: Paul E. Jones; webfinger
Subject: Re: [webfinger] Absolute URI vs URI

John B.

John B.

Is that clear?

Paul

Paul

Paul